## datefudge 1.12

=== Makefile ===
VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')

ifeq (,$(INSTALL_PROGRAM))
    INSTALL_PROGRAM := "install"
endif

compile all: datefudge datefudge.so

install: datefudge datefudge.so datefudge.1
	install -d $(DESTDIR)/usr/lib/
	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)/usr/lib/datefudge.so
	install -d $(DESTDIR)/usr/bin/
	$(INSTALL_PROGRAM) -o root -g root -m 755 datefudge $(DESTDIR)/usr/bin
	install -d $(DESTDIR)/usr/share/man/man1
	install -o root -g root -m 644 datefudge.1 $(DESTDIR)/usr/share/man/man1

datefudge: datefudge.sh
	sed -e 's,@VERSION@,$(VERSION),g' < $< > $@

datefudge.so: datefudge.o
	$(CC) -o $@ -shared $< -ldl -lc

datefudge.o: datefudge.c
	$(CC) -D_REENTRANT $(CFLAGS) -fpic -c -o $@ $<

datefudge.1: datefudge.man
	sed -e 's,@VERSION@,$(VERSION),g' < $< > $@

clean:
	rm -f datefudge.o datefudge.so datefudge

=== debian/changelog ===
datefudge (1.12) unstable; urgency=low

  * Updated maintainer email.
  * Use a Lintian override to not-warn about the shared library
    (which is not linked against, and therefore doesn't require a shlibs entry)
  * Extended the package description
  * added COPYING file to source tarball
  * Updated Standards-Version to 3.6.1 (no changes)
  * Minor build fixes

 -- Matthias Urlichs <smurf@debian.org>  13 Sep 2003 10:00:35 +0200

datefudge (1.11) unstable; urgency=low

  * de-debhelperization problems, part 2:
    removed debian/files
    use debian/shlibs => debian/tmp/DEBIAN/shlibs
      instead of incorrectly writing the latter from debian/rules

 -- Matthias Urlichs <smurf@noris.de>  26 Mar 2003 09:48:03 +0200

datefudge (1.10) unstable; urgency=low

  * Fix debian complaints, part 1

 -- Matthias Urlichs <smurf@noris.de>  24 Mar 2003 21:48:00 +0200

datefudge (1.9) unstable; urgency=low

  * Debhelper removal and cleanup, step 2

 -- Matthias Urlichs <smurf@noris.de>  23 Mar 2003 12:50:45 +0200

datefudge (1.8) unstable; urgency=low

  * Ignore editor files

 -- Matthias Urlichs <smurf@noris.de>  18 Mar 2003 20:17:59 +0200

datefudge (1.7) unstable; urgency=low

  * Debhelper removal and cleanup, step 1

 -- Matthias Urlichs <smurf@noris.de>  18 Mar 2003 20:17:24 +0200

datefudge (1.6) unstable; urgency=low

  * debianized
  * GPLized

 -- Matthias Urlichs <smurf@noris.de>  05 Nov 2002 11:15:33 +0200

datefudge (1.5) unstable; urgency=low

  * Added README

 -- Matthias Urlichs <smurf@noris.de>  17 Oct 2002 07:29:04 +0200

datefudge (1.4) unstable; urgency=low

  * check-in datefudge script

 -- Matthias Urlichs <smurf@noris.de>  14 Mar 2002 12:15:59 +0200

datefudge (1.3) unstable; urgency=low

  * initial check-in

 -- Matthias Urlichs <smurf@noris.de>  14 Mar 2002 12:14:37 +0200

datefudge (1.2) unstable; urgency=low

  * Versionsnummern-Updateskript

 -- Matthias Urlichs <smurf@noris.de>  14 Mar 2002 12:12:31 +0200

datefudge (1.1) unstable; urgency=low

  * Initial repository create

 -- Matthias Urlichs <smurf@noris.de>  14 Mar 2002 12:12:31 +0200

datefudge (1.0) unstable; urgency=low

  * BitKeeper file /var/tmp/b.s.10098/ChangeSet

 -- Matthias Urlichs <smurf@noris.de>  14 Mar 2002 12:12:31 +0200

=== debian/control ===
Source: datefudge
Section: devel
Priority: optional
Maintainer: Matthias Urlichs <smurf@debian.org>
Standards-Version: 3.6.1

Package: datefudge
Architecture: any
Depends: ${shlibs:Depends}
Description: Fake the system date
 This program (and preload library) fakes the system date so that
 programs think the wall clock is ... different.
 .
 The faking is not complete; timestamp on files are not affected in any
 way.
 .
 This package is useful if you want to test the date handling of your
 programs without changing the system clock. Examples: Does it handle
 expired certificates correctly? Does it work on a leap day?

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file to build the "datefudge" Debian package.
# GNU copyright 2002-2003 by Matthias Urlichs.

export CC=gcc
export CFLAGS=-g -Wall
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	STRIP := strip --strip-unneeded \
			--remove-section=.comment --remove-section=.note
else
	STRIP := :
endif

build-arch: build-stamp
build-stamp:
	@if ! test -f debian/control ; then echo "No debian/control file found!" >&2 ; exit 1; fi

	$(MAKE)

	touch build-stamp

clean:
	@if ! test -f debian/control ; then echo "No debian/control file found!" >&2 ; exit 1; fi
	@if ! test $$(id -u) -eq 0 ; then echo "You are not root!" >&2 ; exit 1 ; fi
	rm -f build-stamp

	-$(MAKE) clean

	-rm -f debian/substvars debian/files
	-rm -rf debian/tmp

install: build
	@if ! test -f debian/control ; then echo "No debian/control file found!" >&2 ; exit 1; fi
	@if ! test $$(id -u) -eq 0 ; then echo "You are not root!" >&2 ; exit 1 ; fi

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

# architecture-independent stuff
build-indep binary-indep: 
	# Nothing to do. (In fact there is, but it's too small to split.)
build: build-arch build-indep

# architecture-dependent stuff
binary-arch: build install
	@if ! test -f debian/control ; then echo "No debian/control file found!" >&2 ; exit 1; fi
	@if ! test $$(id -u) -eq 0 ; then echo "You are not root!" >&2 ; exit 1 ; fi
	mkdir -p debian/tmp/DEBIAN

	# install docs
	mkdir -p debian/tmp/usr/share/doc/datefudge
	chmod 755 debian/tmp/usr/share/doc
	chmod 755 debian/tmp/usr/share/doc/datefudge
	install -o root -g root -m 644 README debian/tmp/usr/share/doc/datefudge
	install -o root -g root -m 644 debian/copyright debian/tmp/usr/share/doc/datefudge
	install -o root -g root -m 644 debian/changelog debian/tmp/usr/share/doc/datefudge
	gzip -9f debian/tmp/usr/share/doc/datefudge/changelog
	gzip -9f debian/tmp/usr/share/man/man1/datefudge.1

	# strip library and install control files
	$(STRIP) debian/tmp/usr/lib/datefudge.so
	dpkg-shlibdeps debian/tmp/usr/lib/datefudge.so

	#install -m 644 debian/shlibs debian/tmp/DEBIAN
	install -d debian/tmp/usr/share/lintian/overrides
	install -m 644 debian/overrides debian/tmp/usr/share/lintian/overrides/datefudge
	dpkg-gencontrol -isp

	cd debian/tmp; find . -type f ! -regex '.*/DEBIAN/.*' -printf '%P\0' | xargs -r0 md5sum > DEBIAN/md5sums
	chmod 644 debian/tmp/DEBIAN/md5sums
	dpkg-deb --build debian/tmp ..

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary binary-arch \
		build-indep build-arch install

## datefudge 1.13

=== Makefile ===
--- 
+++ 
@@ -7,8 +7,8 @@
 compile all: datefudge datefudge.so
 
 install: datefudge datefudge.so datefudge.1
-	install -d $(DESTDIR)/usr/lib/
-	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)/usr/lib/datefudge.so
+	install -d $(DESTDIR)/usr/lib/datefudge/
+	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)/usr/lib/datefudge/datefudge.so
 	install -d $(DESTDIR)/usr/bin/
 	$(INSTALL_PROGRAM) -o root -g root -m 755 datefudge $(DESTDIR)/usr/bin
 	install -d $(DESTDIR)/usr/share/man/man1
@@ -27,5 +27,5 @@
 	sed -e 's,@VERSION@,$(VERSION),g' < $< > $@
 
 clean:
-	rm -f datefudge.o datefudge.so datefudge
+	rm -f datefudge.o datefudge.so datefudge datefudge.1

=== debian/changelog ===
datefudge (1.13) unstable; urgency=low

  * QA upload.
  * Package is orphaned (#429467); set maintainer to Debian QA Group.
  * Switch to debhelper.
  * Move datefudge.so to /usr/lib/datefudge as it's not a public library.
  * datefudge.c: Drop <asm/unistd.h> for portability.  Closes: #414335.
  * Makefile: Remove datefudge.1 on clean.
  * debian/copyright: Update FSF address.
  * Conforms to Standards version 3.7.2.

 -- Matej Vela <vela@debian.org>  Mon, 09 Jul 2007 19:10:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: datefudge
 Section: devel
 Priority: optional
-Maintainer: Matthias Urlichs <smurf@debian.org>
-Standards-Version: 3.6.1
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Standards-Version: 3.7.2
+Build-Depends: debhelper (>= 5)
 
 Package: datefudge
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# This file is public domain software, originally written by Joey Hess. 

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export CFLAGS = -g -Wall
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

build: build-stamp
build-stamp:
	dh_testdir

	$(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	$(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/datefudge

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs README
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## datefudge 1.14

=== debian/changelog ===
datefudge (1.14) unstable; urgency=low

  * New maintainer (closes: #429467).
  * Standards-Version: 3.7.3 (no changes).
  * Use debhelper v7 and its minimised rules file.
  * datefudge.c: override clock_gettime(2) called with CLOCK_REALTIME 
    argument to make it possible to fake `date' command (closes: #416175).
  * Update man page, add a simple example.

 -- Robert Luberda <robert@debian.org>  Sat, 10 May 2008 08:21:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: datefudge
 Section: devel
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
-Standards-Version: 3.7.2
-Build-Depends: debhelper (>= 5)
+Maintainer: Robert Luberda <robert@debian.org>
+Standards-Version: 3.7.3
+Build-Depends: debhelper (>= 7)
 
 Package: datefudge
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

build:
	dh build

clean:
	dh clean

install: build
	dh install

binary-arch: install
	dh binary-arch

binary-indep: install
	dh binary-indep

binary: binary-arch binary-indep

.PHONY: build clean install binary-arch binary-indep binary

## datefudge 1.17

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,9 @@
+# $Id: Makefile 19 2011-02-14 22:21:52Z robert $
+
 VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
+
+CC       = gcc
+CFLAGS  += -Wall -Wextra -D_REENTRANT -fpic
 
 ifeq (,$(INSTALL_PROGRAM))
     INSTALL_PROGRAM := "install"
@@ -18,10 +23,10 @@
 	sed -e 's,@VERSION@,$(VERSION),g' < $< > $@
 
 datefudge.so: datefudge.o
-	$(CC) -o $@ -shared $< -ldl -lc
+	$(CC) $(LDFLAGS) -o $@ -shared $< -ldl -lc
 
 datefudge.o: datefudge.c
-	$(CC) -D_REENTRANT $(CFLAGS) -fpic -c -o $@ $<
+	$(CC) $(CFLAGS) -c -o $@ $<
 
 datefudge.1: datefudge.man
 	sed -e 's,@VERSION@,$(VERSION),g' < $< > $@
@@ -29,3 +34,27 @@
 clean:
 	rm -f datefudge.o datefudge.so datefudge datefudge.1
 
+# The first run may possibly fail when it's around midnight, that's why it's run twice.
+test: compile
+	@echo -n "Running a simple date test... "                                ;\
+	export TZ=UTC								 ;\
+	ret1=1; ret2=1                                                           ;\
+	for i in 1 2; do                                                         \
+	        export DATEFUDGE=`LC_ALL=C date --date='yesterday 0:00'  +%s`   ;\
+	        dt=`LC_ALL=C LD_PRELOAD=$(CURDIR)/datefudge.so date --date=12:15 +%F.%T` ;\
+	        exp="1970-01-02.12:15:00"                                       ;\
+	        [ "$$dt" != "$$exp" ] || { echo "OK"; ret1=0; break; }          ;\
+	        echo "failed: expected: $$exp, actual: $$dt"                    ;\
+	        [ $$i = 2 ] || { echo -n "   retrying... "; sleep 2; }          ;\
+	done                                                                    ;\
+	echo -n "Running a simple perl localtime() test... "                    ;\
+	pscr='@t=localtime(time);$$t[5]+=1900;$$t[4]++;printf "%04d-%02d-%02d\n",$$t[5],$$t[4],$$t[3];';\
+	for i in 1 2; do                                                         \
+	        export DATEFUDGE=`LC_ALL=C date --date='yesterday 0:00'  +%s`   ;\
+	        dt=`LD_PRELOAD=$(CURDIR)/datefudge.so perl -e "$$pscr"`         ;\
+	        exp="1970-01-02"                                                ;\
+	        [ "$$dt" != "$$exp" ] || { echo "OK"; ret2=0; break; }          ;\
+	        echo "failed: expected: $$exp, actual: $$dt"                    ;\
+	        [ $$i = 2 ] || { echo -n "   retrying... "; sleep 2; }          ;\
+	done                                                                    ;\
+	exit `expr $$ret1 + $$ret2`;

=== debian/changelog ===
datefudge (1.17) unstable; urgency=low

  * datefudge.{c,man}: Add the `--static' option for static dates.
  * debian/control:
    + Standards-Version: 3.9.2 (no changes);
    + add VCS fields.

 -- Robert Luberda <robert@debian.org>  Thu, 23 Jun 2011 19:38:38 +0200

datefudge (1.16) unstable; urgency=low

  * datefudge.c: don't override clock_gettime(2) on GNU/Hurd - it seems
    it internally calls gettimeofday(2), which is overridden. This fixes
    FTBFS due to test failure on that platform.
  * Makefile: add test for `perl localtime()'.

 -- Robert Luberda <robert@debian.org>  Mon, 14 Feb 2011 23:03:20 +0100

datefudge (1.15) unstable; urgency=low

  * Use the `3.0 (native)' source format.
  * Switch to debhelper v8.
  * Standards-Version: 3.9.1 (no changes).
  * debian/rules:
    + provide build-arch and build-indep targets;
    + call dpkg-buildflags to set CFLAGS and LDFLAGS;
    + simplify the file.
  * Reword the restriction in README (closes: #416174).
  * Update debian/copyright a bit.
  * Makefile: add a simple test case.

 -- Robert Luberda <robert@debian.org>  Sun, 13 Feb 2011 13:28:08 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,14 @@
 Section: devel
 Priority: optional
 Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 3.7.3
-Build-Depends: debhelper (>= 7)
+Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 8)
+Vcs-Git: git://anonscm.debian.org/users/robert/datefudge.git
+Vcs-Browser: http://anonscm.debian.org/git/users/robert/datefudge.git
 
 Package: datefudge
 Architecture: any
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Fake the system date
  This program (and preload library) fakes the system date so that
  programs think the wall clock is ... different.

=== debian/rules ===
#!/usr/bin/make -f
# $Id: rules 17 2011-02-13 12:29:49Z robert $

export CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

binary binary-arch build build-arch clean:
	dh $@

binary-indep build-indep: # Nothing to do

.PHONY: clean                                   \
	build-indep   build-arch   build        \
	binary-indep  binary-arch  binary

## datefudge 1.17build1

=== debian/changelog ===
datefudge (1.17build1) quantal; urgency=low

  * Rebuild for new armel compiler default of ARMv5t.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 01 Oct 2012 20:57:35 +0100

## datefudge 1.18

=== Makefile ===
--- 
+++ 
@@ -9,27 +9,35 @@
     INSTALL_PROGRAM := "install"
 endif
 
-compile all: datefudge datefudge.so
+prefix	= /usr
+libdir 	= $(prefix)/lib/datefudge
+libarch	=
+marchpt = $(shell echo '$(libarch)' | sed -e 's|[^-]|*|g; s|\*\**|*|g; s|^.|/&|')
+bindir	= $(prefix)/bin
+mandir	= $(prefix)/share/man
+
+all compile: datefudge datefudge.so datefudge.1
 
 install: datefudge datefudge.so datefudge.1
-	install -d $(DESTDIR)/usr/lib/datefudge/
-	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)/usr/lib/datefudge/datefudge.so
-	install -d $(DESTDIR)/usr/bin/
-	$(INSTALL_PROGRAM) -o root -g root -m 755 datefudge $(DESTDIR)/usr/bin
-	install -d $(DESTDIR)/usr/share/man/man1
-	install -o root -g root -m 644 datefudge.1 $(DESTDIR)/usr/share/man/man1
+	install -d $(DESTDIR)$(libdir)/$(libarch)
+	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)$(libdir)/$(libarch)/datefudge.so
+	install -d $(DESTDIR)$(bindir)
+	$(INSTALL_PROGRAM) -o root -g root -m 755 datefudge $(DESTDIR)$(bindir)
+	install -d $(DESTDIR)$(mandir)/man1
+	install -o root -g root -m 644 datefudge.1 $(DESTDIR)$(mandir)/man1
 
 datefudge: datefudge.sh
-	sed -e 's,@VERSION@,$(VERSION),g' < $< > $@
+datefudge.1: datefudge.man
+
+datefudge datefudge.1:
+	sed -e 's,@VERSION@,$(VERSION),g; s,@MULTIARCH_PATTERN@,$(marchpt),g; s,@LIBDIR@,$(libdir),g;' \
+	< $< > $@
 
 datefudge.so: datefudge.o
 	$(CC) $(LDFLAGS) -o $@ -shared $< -ldl -lc
 
 datefudge.o: datefudge.c
 	$(CC) $(CFLAGS) -c -o $@ $<
-
-datefudge.1: datefudge.man
-	sed -e 's,@VERSION@,$(VERSION),g' < $< > $@
 
 clean:
 	rm -f datefudge.o datefudge.so datefudge datefudge.1

=== debian/changelog ===
datefudge (1.18) unstable; urgency=low

  * Introduce multi-arch support which allows one to use datefudge with 32-bit
    commands on 64-bit system (providing that both 32-bit and 64-bit versions
    of this package are installed on system) (LP: #1103281):
    + install datefudge.so library into /usr/lib/datefudge/<arch-tripplet>;
    + add each /u/l/d/<arch-tripplet> to LD_LIBRARY_PATH in datefudge scipt;
    + mark binary package as `Multi-Arch: same'.
  * Use debhelper v9.
  * debian/control:
    + fix Vcs-Browser field;
    + Standards-Version: 3.9.4 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 11 May 2013 19:02:11 +0200

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,16 @@
 Section: devel
 Priority: optional
 Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 8)
+Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9)
 Vcs-Git: git://anonscm.debian.org/users/robert/datefudge.git
-Vcs-Browser: http://anonscm.debian.org/git/users/robert/datefudge.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/robert/datefudge.git;a=summary
 
 Package: datefudge
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: Fake the system date
  This program (and preload library) fakes the system date so that
  programs think the wall clock is ... different.

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

export libarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

binary binary-arch build build-arch clean:
	dh $@


binary-indep build-indep: # Nothing to do

override_dh_auto_build:
	dh_auto_build -- libarch="$(libarch)"

override_dh_auto_install:
	dh_auto_install -- libarch="$(libarch)"


.PHONY: clean                                   \
	build-indep   build-arch   build        \
	binary-indep  binary-arch  binary       \
	override_dh_auto_build override_dh_auto_install

## datefudge 1.18ubuntu3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
 
-CC       = gcc
+CC       = $(hostarch)-gcc
 CFLAGS  += -Wall -Wextra -D_REENTRANT -fpic
 
 ifeq (,$(INSTALL_PROGRAM))

=== debian/changelog ===
datefudge (1.18ubuntu3) trusty; urgency=low

  * Use DEB_HOST_GNU_TYPE for cross-builds, not DEB_HOST_ARCH.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 04 Dec 2013 22:39:36 -0700

datefudge (1.18ubuntu2) trusty; urgency=low

  * Fix build on i386.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Dec 2013 17:03:03 +0100

datefudge (1.18ubuntu1) trusty; urgency=low

  * Allow the package to cross-build.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Dec 2013 16:25:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: datefudge
 Section: devel
 Priority: optional
-Maintainer: Robert Luberda <robert@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
 Standards-Version: 3.9.4
 Build-Depends: debhelper (>= 9)
 Vcs-Git: git://anonscm.debian.org/users/robert/datefudge.git

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
 
 export libarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+export hostarch := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 binary binary-arch build build-arch clean:
 	dh $@

## datefudge 1.21

=== debian/changelog ===
datefudge (1.21) unstable; urgency=medium

  * datefudge.sh: don't fail when its date argument happens to be equal
    to the current time (i.e. make `datefudge now some_command' work).
  * Enable all hardening options in debian/rules.
  * Update man page to mention that the date can be given in any format
    accepted by date(1) command.
  * Switch debian/copyright to the DEP-5 format.
  * Use https in Vcs-Browser field (lintian).
  * Standards-Version: 3.9.6 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 13 Feb 2016 15:19:41 +0100

datefudge (1.20) unstable; urgency=medium

  * datefudge.c: don't override time(2) on GNU/Hurd, as it seems to
    internally call gettimeofday(2), which is overridden. This fixes
    FTBFS on that platform.

 -- Robert Luberda <robert@debian.org>  Mon, 16 Dec 2013 23:32:47 +0100

datefudge (1.19) unstable; urgency=medium

  * Use `*-*' as multi-arch pattern to make sure the datefudge script is the
    same on all architectures, including 'hurd-i386' (closes: #730766).
  * Install datefudge.so into /usr/lib<arch>/datefudge instead of using
    an extra private dir /usr/lib/datefudge/<arch> (closes: #711892).
  * Cleanup makefiles a bit and add support for cross-compiling.
  * Standards-Version: 3.9.5 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 14 Dec 2013 21:06:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: datefudge
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 3.9.4
+Maintainer: Robert Luberda <robert@debian.org>
+Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 9)
 Vcs-Git: git://anonscm.debian.org/users/robert/datefudge.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/robert/datefudge.git;a=summary
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=users/robert/datefudge.git;a=summary
 
 Package: datefudge
 Architecture: any

## datefudge 1.22

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,6 @@
-# $Id: Makefile 19 2011-02-14 22:21:52Z robert $
-
 VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
 
-CC       = $(hostarch)-gcc
+CC      ?= gcc
 CFLAGS  += -Wall -Wextra -D_REENTRANT -fpic
 
 ifeq (,$(INSTALL_PROGRAM))
@@ -10,17 +8,19 @@
 endif
 
 prefix	= /usr
-libdir 	= $(prefix)/lib/datefudge
-libarch	=
-marchpt = $(shell echo '$(libarch)' | sed -e 's|[^-]|*|g; s|\*\**|*|g; s|^.|/&|')
+libdir 	= $(prefix)/lib
+ifneq (,$(libarch))
+# The `*-*' pattern matches to both hurd-i386 and e.g. i386-linux-gnu
+marchpt = /*-*
+endif
 bindir	= $(prefix)/bin
 mandir	= $(prefix)/share/man
 
 all compile: datefudge datefudge.so datefudge.1
 
 install: datefudge datefudge.so datefudge.1
-	install -d $(DESTDIR)$(libdir)/$(libarch)
-	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)$(libdir)/$(libarch)/datefudge.so
+	install -d $(DESTDIR)$(libdir)/$(libarch)/datefudge
+	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)$(libdir)/$(libarch)/datefudge/datefudge.so
 	install -d $(DESTDIR)$(bindir)
 	$(INSTALL_PROGRAM) -o root -g root -m 755 datefudge $(DESTDIR)$(bindir)
 	install -d $(DESTDIR)$(mandir)/man1
@@ -37,7 +37,7 @@
 	$(CC) $(LDFLAGS) -o $@ -shared $< -ldl -lc
 
 datefudge.o: datefudge.c
-	$(CC) $(CFLAGS) -c -o $@ $<
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<
 
 clean:
 	rm -f datefudge.o datefudge.so datefudge datefudge.1

=== debian/changelog ===
datefudge (1.22) unstable; urgency=medium

  * datefudge.c: Apply the following fixes from Thorsten Glaser
    (closes: #853724):
    + Operate more efficiently, especially if fudging to the epoch.
    + Fix running on 32-bit systems with 64-bit time_t (such as x32).
  * datefudge.man: Document that datefudge might be affected by the
    Y2K38 problem on some systems.
  * Use https in Vcs-Git and switch Vcs-Browser to cgit.
  * Standards-Version: 3.9.6 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 04 Feb 2017 22:59:11 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: devel
 Priority: optional
 Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9)
-Vcs-Git: git://anonscm.debian.org/users/robert/datefudge.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=users/robert/datefudge.git;a=summary
+Vcs-Git: https://anonscm.debian.org/git/users/robert/datefudge.git
+Vcs-Browser: https://anonscm.debian.org/cgit/users/robert/datefudge.git/
 
 Package: datefudge
 Architecture: any

## datefudge 1.22+nmu1

=== debian/changelog ===
datefudge (1.22+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 11:10:47 +0800

## datefudge 1.23

=== debian/changelog ===
datefudge (1.23) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Robert Luberda ]
  * Makefile: No longer require root privileges for installation;
    set `Rules-Requires-Root' to `no' in debian/control.
  * Build with debhelper v12.
  * datefudge.sh: introduce '--add-ld-preload|-l arg' option to prepend
    given arg to LD_LPRELOAD variable, what might be useful for Address
    Sanitizer and other santizers (closes: #873577).
  * datefudge.man: document the above option.
  * Add simple tests for autopkgtest.
  * Standards-Version: 4.4.0.

 -- Robert Luberda <robert@debian.org>  Fri, 02 Aug 2019 20:09:51 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9)
-Vcs-Git: https://anonscm.debian.org/git/users/robert/datefudge.git
-Vcs-Browser: https://anonscm.debian.org/cgit/users/robert/datefudge.git/
+Standards-Version: 4.4.0
+Build-Depends: debhelper (>= 12)
+Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/debian/datefudge.git
+Vcs-Browser: https://salsa.debian.org/debian/datefudge
 
 Package: datefudge
 Architecture: any

## datefudge 1.23ubuntu1

=== debian/changelog ===
datefudge (1.23ubuntu1) focal; urgency=medium

  * Update gettimeofday prototype to take the timezone as void *, as required
    by glibc 2.31.

 -- William Grant <wgrant@ubuntu.com>  Mon, 06 Apr 2020 16:12:13 +1000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: datefudge
 Section: devel
 Priority: optional
-Maintainer: Robert Luberda <robert@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
 Standards-Version: 4.4.0
 Build-Depends: debhelper (>= 12)
 Rules-Requires-Root: no

=== debian/tests/control ===
Test-Command: a='2019-07-31 23:01:12'; b=$(datefudge "$a" date '+%F %T'); echo " >> $b"; test "$b" = "$a"
Depends: @, coreutils
Features: test-name=basic-check-with-date

Test-Command: a='2019-07-31 23:01:12'; b=$(datefudge "$a" sh -c 'sleep 2; date "+%F %T"'); echo " >> $b"; test "$b" = '2019-07-31 23:01:14'
Depends: @, coreutils
Features: test-name=check-with-sleep-date

Test-Command: a='2019-07-31 23:01:12'; b=$(datefudge -s "$a" sh -c 'sleep 2; date "+%F %T"'); echo " >> $b"; test "$b" = "$a"
Depends: @, coreutils
Features: test-name=check-static-with-sleep-date

Test-Command: a='2020-02-29 01:02:03'; b=$(datefudge "$a" perl -e 'print scalar(localtime);'); echo " >> $b"; test "$b" = 'Sat Feb 29 01:02:03 2020'
Depends: @, perl
Features: test-name=check-with-perl-localtime

Test-Command: a='now'; b=$(env -u LD_PRELOAD datefudge "$a" sh -c 'echo $LD_PRELOAD'); echo " >> $b"; test "$b" = 'datefudge.so'
Depends: @, coreutils
Features: test-name=check-default-ld-library-path

Test-Command: a='now'; b=$(env -u LD_PRELOAD datefudge -l /dev/null "$a" sh -c 'echo $LD_PRELOAD' 2>/dev/null || :); echo " >> $b"; test "$b" = '/dev/null:datefudge.so'
Depends: @, coreutils
Features: test-name=check-prepending-ld-library-path

## datefudge 1.24

=== Makefile ===
--- 
+++ 
@@ -20,11 +20,11 @@
 
 install: datefudge datefudge.so datefudge.1
 	install -d $(DESTDIR)$(libdir)/$(libarch)/datefudge
-	$(INSTALL_PROGRAM) -o root -g root -m 644 datefudge.so $(DESTDIR)$(libdir)/$(libarch)/datefudge/datefudge.so
+	$(INSTALL_PROGRAM) -m 644 datefudge.so $(DESTDIR)$(libdir)/$(libarch)/datefudge/datefudge.so
 	install -d $(DESTDIR)$(bindir)
-	$(INSTALL_PROGRAM) -o root -g root -m 755 datefudge $(DESTDIR)$(bindir)
+	$(INSTALL_PROGRAM) -m 755 datefudge $(DESTDIR)$(bindir)
 	install -d $(DESTDIR)$(mandir)/man1
-	install -o root -g root -m 644 datefudge.1 $(DESTDIR)$(mandir)/man1
+	install -m 644 datefudge.1 $(DESTDIR)$(mandir)/man1
 
 datefudge: datefudge.sh
 datefudge.1: datefudge.man

=== debian/changelog ===
datefudge (1.24) unstable; urgency=medium

  [ Debian Janitor ]
  * Update standards version to 4.4.1, no changes needed.
  * Set debhelper-compat version in Build-Depends.
  * Fix day-of-week for changelog entries 1.12, 1.11, 1.10, 1.9, 1.8,
    1.7, 1.6, 1.5, 1.4, 1.3, 1.2, 1.1, 1.0.

  [ Robert Luberda ]
  * Fix FTBFS on hurd-i386: Necessary functions disabled (closes: #945599).
    Thanks to Paul Sonnenschein for the patch.
  * Fix FTBFS with glibc 2.31 (conflicting gettimeofday prototype) (closes:
    #964227). Thanks to Aurelien Jarno for the patch.
  * Bump debhelper's compact level to 13.
  * Standards-Version: 4.5.0.

 -- Robert Luberda <robert@debian.org>  Tue, 14 Jul 2020 11:11:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: datefudge
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 4.4.0
-Build-Depends: debhelper (>= 12)
+Maintainer: Robert Luberda <robert@debian.org>
+Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13)
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/datefudge.git
 Vcs-Browser: https://salsa.debian.org/debian/datefudge

## datefudge 1.26

=== debian/changelog ===
datefudge (1.26) unstable; urgency=low

  * Fix autpokgtest case introduced recently for #946776 so that it does not
    depend on time zone.

 -- Robert Luberda <robert@debian.org>  Sun, 14 Jan 2024 11:16:31 +0100

datefudge (1.25) unstable; urgency=low

  * Provide 64-bit versions of time functions on 32-bit architectures
    (closes: #1028587, LP: #2002803).
  * Cleanup source code, and reformat it with clang-format.
  * In --static mode, set sub-seconds part to 0 (closes: #946776).
  * Mention in man page and README file existence of libfaketime package,
    that might be considered for more advanced functionalities than the
    ones provided by datefudge.
  * Standards-Version: 4.6.2 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 13 Jan 2024 12:52:30 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 13)
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/datefudge.git

## datefudge 1.27

=== Makefile ===
--- 
+++ 
@@ -1,17 +1,17 @@
 VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
 
 CC      ?= gcc
-CFLAGS  += -Wall -Wextra -D_REENTRANT -fpic
+CFLAGS  += -Wall -Wextra -D_REENTRANT -fpic # -D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64
 
 ifeq (,$(INSTALL_PROGRAM))
-    INSTALL_PROGRAM := "install"
+	INSTALL_PROGRAM := "install"
 endif
 
 prefix	= /usr
 libdir 	= $(prefix)/lib
 ifneq (,$(libarch))
-# The `*-*' pattern matches to both hurd-i386 and e.g. i386-linux-gnu
-marchpt = /*-*
+	# The `*-*' pattern matches to both hurd-i386 and e.g. i386-linux-gnu
+	marchpt = /*-*
 endif
 bindir	= $(prefix)/bin
 mandir	= $(prefix)/share/man
@@ -26,6 +26,9 @@
 	install -d $(DESTDIR)$(mandir)/man1
 	install -m 644 datefudge.1 $(DESTDIR)$(mandir)/man1
 
+format-sources:
+	clang-format --style=LLVM -i *.c
+
 datefudge: datefudge.sh
 datefudge.1: datefudge.man
 
@@ -33,14 +36,15 @@
 	sed -e 's,@VERSION@,$(VERSION),g; s,@MULTIARCH_PATTERN@,$(marchpt),g; s,@LIBDIR@,$(libdir),g;' \
 	< $< > $@
 
-datefudge.so: datefudge.o
-	$(CC) $(LDFLAGS) -o $@ -shared $< -ldl -lc
+datefudge.so: datefudge.o datefudge64.o
+	$(CC) $(LDFLAGS) -o $@ -shared $^ -ldl -lc
 
-datefudge.o: datefudge.c
+%.o: %.c datefudge.c Makefile
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<
 
 clean:
-	rm -f datefudge.o datefudge.so datefudge datefudge.1
+	rm -f datefudge*.o datefudge.so datefudge datefudge.1
+
 
 # The first run may possibly fail when it's around midnight, that's why it's run twice.
 test: compile
@@ -66,3 +70,5 @@
 	        [ $$i = 2 ] || { echo -n "   retrying... "; sleep 2; }          ;\
 	done                                                                    ;\
 	exit `expr $$ret1 + $$ret2`;
+
+.PHONY: all compile install test format-sources

=== debian/changelog ===
datefudge (1.27) unstable; urgency=medium

  * Fix FTBFS by explicitly passing "abi=-time64" to DEB_BUILD_MAINT_OPTIONS
    in debian/rules, so that we can still override both 32- and 64-bit time
    functions on architectures that support it (closes: #1069478).
  * Standards-Version: 4.7.0 (no changes).

 -- Robert Luberda <robert@debian.org>  Fri, 30 Aug 2024 09:38:42 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13)
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/datefudge.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all abi=-time64

include /usr/share/dpkg/architecture.mk

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  export CC := $(DEB_HOST_GNU_TYPE)-gcc
else
  export CC := gcc
endif

export libarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

=== debian/tests/control ===
--- 
+++ 
@@ -10,6 +10,10 @@
 Depends: @, coreutils
 Features: test-name=check-static-with-sleep-date
 
+Test-Command: a='2024-01-02 18:03:04.56789'; b=$(datefudge -s "$a" sh -c 'sleep 1.3; date "+%T %N"'); echo " >> $b"; test "$b" = "18:03:04 000000000"
+Depends: @, coreutils
+Features: test-name=check-static-resets-sub-seconds-bug946776
+
 Test-Command: a='2020-02-29 01:02:03'; b=$(datefudge "$a" perl -e 'print scalar(localtime);'); echo " >> $b"; test "$b" = 'Sat Feb 29 01:02:03 2020'
 Depends: @, perl
 Features: test-name=check-with-perl-localtime

## datefudge 1.27build1

=== debian/changelog ===
datefudge (1.27build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 16 Jan 2026 19:43:01 +0000
